unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    Bgas1: TButton;
    BBremse1: TButton;
    GroupBox2: TGroupBox;
    BBremse3: TButton;
    Bgas3: TButton;
    GroupBox3: TGroupBox;
    BBremse2: TButton;
    Bgas2: TButton;
    Button1: TButton;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Bgas1Click(Sender: TObject);
    procedure BBremse1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

type TAuto = class(Tobject) //Klassendeklaration
     //Felder
     x, y, v, farbe: Integer; // x,y- Position; Geschwindigkeit, farbe
     //Methoden
     procedure Gasgeben(dv: integer); // erhht v um dv
     procedure Bremsen(dv: integer);  // verringert vum dv
     procedure Zeichnen(canv: Tcanvas; farbe: Tcolor);
end;

var
  Form1: TForm1;
  auto1, auto2, auto3: Tauto;

implementation
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  color := claqua;
  Canvas.Brush.Style := bsclear; // Fllmuster tarnsparent
  timer1.Interval := 100;
  Auto1 := TAuto.create;
  with Auto1 do Begin
    x := 100;
    y := 50;
    v := 0;
    farbe := clred;
  end;
  Auto2 := TAuto.create;
  with Auto2 do Begin
    x := 100;
    y := 150;
    v := 0;
    farbe := clblue;
  end;
  Auto3 := TAuto.create;
  with Auto3 do Begin
    x := 100;
    y := 250;
    v := 0;
    farbe := clgreen;
  end;
end;


procedure TAuto.Gasgeben(dv: integer); // erhht v um dv
begin
  v := v + dv;
end;
procedure TAuto.Bremsen(dv: integer);  // verringert vum dv
begin
  v := v -dv;
end;
procedure TAuto.Zeichnen(canv: Tcanvas; farbe: Tcolor);
begin
  with Canv do Begin
    Pen.color := farbe;       //Stiftfarbe zuweisen
    rectangle(x+10,y+5,x+30,y+20); //linkes Hinterrad
    rectangle(x+10,y+70,x+30,y+85);//rechtes Hinterrad
    rectangle(x+80,y+10,x+100,y+20);//linkes Vorderrad
    rectangle(x+80,y+70,x+100,y+80);//linkes Hinterrad
    moveTo(x+20,y+20); Lineto(x+20,y+30); //linke Hinteachse
    moveTo (x+20,y+60); LineTo(x+20,y+70); //rechte Hinterachse
    moveTo (x+90,y+20); LineTo(x+90,y+35); //linke Vorderachse
    moveTo (x+90,y+55); LineTo(x+90,y+70); //rechte Vorderachse
    moveTo (x,y+30); LineTo(x+70,y+30);    //linke Vorderachse
    LineTo(x+110,y+40); Lineto(x+110,y+50);
    LineTo(x+70,y+60); LineTo(x,y+60); LineTo(x,y+30); //rechte Karosserie
    Ellipse(x+45,y+35,x+65,y+55);

  End;
end;

procedure anzeigen(auto: Tauto);
begin
  auto.Zeichnen(form1.canvas,Form1.color); //Alte Position verschwindet
  auto.x := auto.x + trunc(auto.v);        //Neue position
  if auto.x > form1.width then auto.x := 0;
  if auto.x <0 then auto.x := form1.width;
  auto.Zeichnen(form1.canvas,auto.farbe)
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
  anzeigen(auto1);
  anzeigen(auto2);
  anzeigen(auto3);
end;


procedure TForm1.Bgas1Click(Sender: TObject);
begin
   if sender = Bgas1 then
      auto1.Gasgeben(2) else
       if sender = Bgas2 then
         auto2.Gasgeben(4) else
           auto3.Gasgeben(8);
end;

procedure TForm1.BBremse1Click(Sender: TObject);
begin
 if sender = Bbremse1 then
   auto1.Bremsen(2) else
    if sender = Bbremse2 then
       auto2.Bremsen(4) else
         auto3.Bremsen(8);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 close
end;

end.

